package openacunetix;
import java.io.BufferedReader;
import openacunetix.gui;
import openacunetix.HTMLParser;
import openacunetix.HTMLParserCallback;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;
import java.io.*;
import java.net.*;
import javax.swing.text.html.HTMLEditorKit;

/* * * * * * * * 
 *
 * openACUNETIX is an application designed to be an open-source alternative
 * to Acunetix ( http://www.acunetix.com/ ), a comprehensive web application
 * security scanner.
 * 
 * v0.1a features:
 * 
 * -> auditing both POST and GET variables
 * -> user-definable list 
 *
 * * * * * * * * 
 * 
 * scanner.java is the engine to test web apps for sql injection
 * and cross-site scripting vulnerabilities.
 * 
 * * * * * * * *
 * 
 * html parsing source from Adam_:
 * http://www.javaworld.com/javaforums/showflat.php?Cat=2&Number=30173&Main=11291
 * 
 * accessed on november 5th, 2008
 * 
 * * * * * * * *
 * 
 * developed by John Martinelli
 * 				john@martinelli.com
 * 				http://redlevel.org
 * 
 * @param args
 * @throws FileNotFoundException 
 * 
 */

public class scanner {
	
	// this class is executed to run the program.
	
	public static String[] inject = new String[512];
	public static String[] match = new String[512];
	public static String[] method = new String[512]; // get or post
	public static String[] action = new String[512]; // the target url
	public static String[] variable = new String[512]; // the variable
	public static int injects = 0, matches = 0;
	
	public static void main(String[] args) throws FileNotFoundException {
		loadinject();
		loaderror();
		gui.main(null);	}
	
	private static void loadinject() throws FileNotFoundException {
	
		/* load our strings to inject into our HTML forms
		
	 	   ' or 'x'='x
		   >"><script>alert(1)</script>
		   etc. */
		
		Scanner injectScan = new Scanner(new BufferedReader(new FileReader("inject.txt")));
		
		while(injectScan.hasNext()) { // read in the database to array
			inject[injects] = injectScan.nextLine(); // load our injection strings into the array
			injects++;
		}
	}
	
	private static void loaderror() throws FileNotFoundException {
		
		/* load our strings to check against the output of our HTML forms
		
		   <script>alert(1)</script>
		   sql errors
		   etc. */
	
		Scanner matchScan = new Scanner(new BufferedReader(new FileReader("errors.txt")));

		while(matchScan.hasNext()) { // read in the database to arrays
			match[matches] = matchScan.nextLine();
			matches++; // increase the amount of match strings we report
		}
	}
	
	private static void outputparse(String backput, int x, int scanLoop) {
	
		/*
		 * here, we'll take our output from attempt(), and then run
		 * it against our detection array
		 */
		
		for (int resultLoop = 0; resultLoop < matches; resultLoop++) {
			if (backput.contains(match[resultLoop])) {
				gui.console.append("\n\n[$] VULNERABILITY DETECTED [$] \n\nvariable: " + scanner.variable[x] + "\nmethod: " + scanner.method[x] + "\naction: " + scanner.action[x] + "\ninput: " + inject[scanLoop] + "\nerror produced: " + match[resultLoop]);
			}
		}
	}
	
	public static void attempt(String string) throws IOException {
	
		// inject malicious strings and attempt to get our feedback
		
		int x;
		gui.console.append("\n[!] Scanning " + string);
		
		// get our non-adulterated source
			
		HTMLParser kit = new HTMLParser();
		HTMLEditorKit.Parser parser = kit.getParser();
		HTMLParserCallback.variablenumber = 0;
		
		try { // set up our socket to grab our page's source.
			URL url = new URL(string);
			HttpURLConnection connection = (HttpURLConnection) url.openConnection();
			Reader reader = new InputStreamReader(connection.getInputStream());
			HTMLEditorKit.ParserCallback callback = new HTMLParserCallback();
			parser.parse(reader, callback, true);
		} catch (Exception e) {
			System.err.println(e);
		}

		for (x = 0; x < HTMLParserCallback.variablenumber; x++) {
			String backput = ""; // set up our buffer for reporting vulnerabilities
			String newurl;
			int scanLoop = 0;
			
			if (scanner.variable[x] == null) break;
						
			for (scanLoop = 0; scanLoop < injects; scanLoop++) {
			
			// take our old URL, break it apart, and then
			// update it with our forms' action URL
				
			URL buf = new URL(string);
			newurl = buf.getProtocol() + "://" + buf.getHost() + buf.getPath() + "/../" + scanner.action[x]; // properly craft our URL, as well as append our form's target (the 'action')
			URL url = new URL(newurl);
			
			if (scanner.method[x].toUpperCase().equals("POST")) {

				HttpURLConnection connection = (HttpURLConnection) url.openConnection();			
	
				connection.setRequestMethod(scanner.method[x].toUpperCase()); 
				connection.setDoOutput(true); // we want to send output.
			
				OutputStreamWriter writer = new OutputStreamWriter(connection.getOutputStream());
	
				writer.write(scanner.variable[x] + "=" + URLEncoder.encode(inject[scanLoop], "UTF-8")); // send our attack string
				writer.close(); 

				BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
			
				while (reader.ready() == true) {
					backput = backput + reader.readLine(); // read in, line-by-line, from the URL connection's input stream
				}
			
				reader.close();
				outputparse(backput, x, scanLoop);
			
			} else if (scanner.method[x].toUpperCase().equals("GET")) {
				
				int port = 80;
				String pather[] = new String[256];
				String backputtemp;
				String finalUrl = "GET "; // the beginning of our GET HTTP request.

				pather = buf.getPath().split("/"); // tear apart our URL for proper data transfer		
			
				for (int patherLoop = 0; patherLoop < pather.length-1; patherLoop++) {
					finalUrl = finalUrl + pather[patherLoop] + "/"; } // take our torn apart URL, and put it back together with the correct 'action'
			
				finalUrl = finalUrl + scanner.action[x] + "?" + scanner.variable[x] + "=" + URLEncoder.encode(inject[scanLoop], "UTF-8") + " HTTP/1.0\r\nFrom: open@acunetix.com\r\nUser-Agent: openACUNETIX/1.1\r\nHost: " + url.getHost() + "\r\n\r\n"; // append our necessary payload
			
				if (buf.getPort() == -1) port = 80; // make sure port = 80 if it's not specified.
				else port = buf.getPort();
								
				Socket socket = new Socket(buf.getHost(), port);
				PrintWriter to = new PrintWriter(socket.getOutputStream());
				BufferedReader from = new BufferedReader(new InputStreamReader(socket.getInputStream()));

				to.print(finalUrl); // send our packet!
				to.flush();
				
			    while ((backputtemp = from.readLine()) != null) { 
			        backput = backput + backputtemp; } 
			      
			    from.close();
				to.close();
			    socket.close();
			    
			    outputparse(backput, x, scanLoop); // parse the data we get back.
				}	
			}
		}
		gui.console.append("\n\n[!] Scan completed.\n");
	} 
}


